<?php
$title = 'Переход по ссылке';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");

if (isset($active) && $sys['modules']['serf'] == 1) {

    echo '<div class="title">Переход по ссылке</div>';

    $stmt_count = $connect->prepare("select count(*) from `link` where `click` > '0' and `status` = '1' and `id` = ?");
    $stmt_count->execute(array($id));

    if ($stmt_count->fetchColumn()) {

        // prepared
        $in_click = $connect->prepare("insert into `click` set `time` = ?, `link` = ?, `uid` = ?, `ua` = ?");
        $link = $connect->prepare("update `link` set `click` = `click` - '1' where `id` = ?");
        $strow = $connect->prepare("select * from `link` where `id` = ?");

        if (!isset($_SESSION['serf_on']) && $sys['modules']['captcha_s'] == 1) {

            echo '<div class="menu"><div class="danger">Пройдите проверку на странице просмотра сайтов!</div></div>';

        }
        elseif (is_forbid_browser($id)) {

            echo '<div class="menu"><div class="danger">Вы не можете переходить по ссылке с этого браузера!</div></div>';

        }
        elseif (isset($_SESSION['serf_ban']) && $_SESSION['serf_ban'] > time() - $sys['system']['serf_ban']) {

            echo '<div class="menu"><div class="forbidden">Вы забанены на '.quantDec($sys['system']['serf_ban'], ['секунда', 'секунды', 'секунд']).'!</div></div>';

        }
        elseif (isset($_SESSION['c_time']) && $_SESSION['c_time'] > time() - $sys['system']['ctime']) {

            $_SESSION['serf_ban'] = time(); // баним

            echo '<div class="menu"><div class="danger">Просматривайте сайты не менее '.quantDec($sys['system']['ctime'], ['секунда', 'секунды', 'секунд']).'!</div></div>';

        } else {

            $strow->execute(array($id));
            $row = $strow->fetch(); 

            $stmt_click->execute(array($user['id'], $id));

            if ($row['uid'] == $user['id']) {

                echo '<div class="menu"><div class="forbidden">Нельзя переходить по своей ссылке!</div></div>';

            }
            elseif ($stmt_click->fetchColumn()) {

                echo '<div class="menu"><div class="forbidden">Вы уже переходили по этой ссылке сегодня!</div></div>';

            }
            elseif (pay($row['cena'], $user['id']) && $in_click->execute(array(time(), $id, $user['id'], $ua)) && $link->execute(array($id))) {

                ratingUser($sys['rating']['click'], $user['id']);

                $_SESSION['c_time'] = time();

                header('Location: '.$row['url']);

            } else {

                echo '<div class="menu">Произошла ошибка!</div>';

            }

        }

    } else {
        echo '<div class="menu">Нет такой ссылки!</div>';
    }

} else {
    header('Location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
 ?>